FourthMVCAppMy/Models/Ads/AdCreateModel.cs
using System.ComponentModel.DataAnnotations;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace FourthMVCAppMy.Models.Ads
{
    public class AdCreateModel
    {
        [Display(Name = "Дата создания объявления")]
        [Required]
        public string DateOfСreation { get; set; }

        [Display(Name = "Заголовок объявления")]
        [Required]
        public string Title { get; set; }

        [Display(Name = "Цена")]
        [Required]
        public decimal Price { get; set; }

        [Display(Name = "Описание объявления")]
        [Required]
        public string Description { get; set; }

        public int CategoryId { get; set; }

        [Display(Name = "Категория")]
        [Required]
        public string Categories { get; set; }

        public SelectList CategoriesSelect { get; set; }

        [Display(Name = "Контактное лицо")]
        [Required]
        public string ContactName { get; set; }

        [Display(Name = "Контакты")]
        [Required]
        public string ContactPhone { get; set; }

        [Display(Name = "Изображение")]
        [Required]
        public IFormFile Image { get; set; }
    }
}

FourthMVCAppMy/Models/Ads/AdFilterModel.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace FourthMVCAppMy.Models.Ads
{
    public class AdFilterModel
    {
        [Display(Name = "По автору темы")]
        public string Author { get; set; }

        [Display(Name = "По ключевому слову")]
        public string SearchKey { get; set; }

        [Display(Name = "Цена от")]
        public decimal? PriceFrom { get; set; }

        [Display(Name = "Цена до")]
        public decimal? PriceTo { get; set; }
        
        public AdModel AdModel { get; set; }

        public List<AdModel> Ads { get; set; }
    }
}

FourthMVCAppMy/Models/Ads/AdModel.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using FourthMVCAppMy.DAL.Entities;
using FourthMVCAppMy.Models.Comments;

namespace FourthMVCAppMy.Models.Ads
{
    public class AdModel
    {
        public int Id { get; set; }

        [Display(Name = "Дата создания объявления")]
        [Required]
        public string DateOfСreation { get; set; }

        [Display(Name = "Заголовок объявления")]
        [Required]
        public string Title { get; set; }

        [Display(Name = "Цена")]
        [Required(ErrorMessage = "\"Цена\" должна быть указана")]
        public decimal Price { get; set; }

        [Display(Name = "Описание объявления")]
        [Required]
        public string Description { get; set; }

        [Display(Name = "Имя автора объявления")]
        [Required]
        public string ContactName { get; set; }

        [Display(Name = "Контактный телефон")]
        [Required]
        public string ContactPhone { get; set; }

        public int AuthorId { get; set; }

        [Display(Name = "Автор объявления")]
        [Required]
        public string Author { get; set; }

        public int CategoryId { get; set; }

        [Display(Name = "Категория")]
        [Required]
        public string Categories { get; set; }

        public List<CommentModel> Comments { get; set; }

        public byte[] Image { get; set; }

        public string ImagePath { get; set; }

        public RecordImageType RecordImageType { get; set; }

        public List<GalleryImageModel> Images { get; set; }
    }
}

FourthMVCAppMy/Controllers/AdController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using FourthMVCAppMy.DAL.Entities;
using FourthMVCAppMy.Models;
using FourthMVCAppMy.Models.Ads;
using FourthMVCAppMy.Models.Comments;
using FourthMVCAppMy.Services.Ads.Contracts;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;

namespace FourthMVCAppMy.Controllers
{
    public class AdController : Controller
    {
        private readonly IAdService _adService;
        private readonly UserManager<User> _userManager;

        public AdController(IAdService adService, UserManager<User> userManager)
        {
            if (adService == null)
                throw new ArgumentNullException(nameof(adService));
            if (userManager == null)
                throw new ArgumentNullException(nameof(userManager));

            _adService = adService;
            _userManager = userManager;
        }

        [HttpGet]
        public IActionResult Index(AdFilterModel model)
        {
            try
            {
                var recordModels = _adService.GetAdFilterModel(model);

                model.Ads = recordModels;

                return View(model);
            }
            catch (ArgumentOutOfRangeException ex)
            {
                ViewBag.BadRequestMessage = ex.Message;
                return View("BadRequest");
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [Authorize]
        public IActionResult AdCreate()
        {
            var model = _adService.GetAdCreateModel();
            return View(model);
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> AdCreate(AdCreateModel model)
        {
            try
            {
                User currentUser = await _userManager.GetUserAsync(User);

                _adService.CreateAd(model, currentUser.Id);

                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [AllowAnonymous]
        [HttpGet]
        public IActionResult Details(int adId)
        {
            var adModel = _adService.GetAdById(adId);

            return View(adModel);
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> AddComment(CommentCreateModel model)
        {
            try
            {
                var currentUser = await _userManager.GetUserAsync(User);
                var commentModel = _adService.AddComment(model, currentUser);

                return Ok(commentModel);
            }
            catch (Exception e)
            {
                return StatusCode(500, e.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public IActionResult Upload(GalleryImageCreateModel model)
        {
            try
            {
                _adService.UploadImages(model);
                return RedirectToAction("Details", new { recordId = model.AdId });
            }
            catch (Exception e)
            {
                return StatusCode(500, e.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public IActionResult UploadAjax(int adId)
        {
            try
            {
                GalleryImageCreateModel model = new GalleryImageCreateModel()
                {
                    AdId = adId,
                    Images = Request.Form.Files
                };

                var imageModels = _adService.UploadImages(model);

                return Ok(imageModels.ToList());
            }
            catch (Exception e)
            {
                return StatusCode(500, e.Message);
            }
        }
    }
}

FourthMVCAppMy/Views/Ad/AdCreate.cshtml
@model FourthMVCAppMy.Models.Ads.AdCreateModel

@{
    ViewData["Title"] = "AdCreate";
}

<h1>AdCreate</h1>

<h4>AdAdCreateModel</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="AdCreate" method="post" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Title" class="control-label"></label>
                <input asp-for="Title" class="form-control" />
                <span asp-validation-for="Title" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="CategoryId" class="control-label"></label>
                <select asp-for="CategoryId" class="form-control" asp-items="Model.CategoriesSelect">
                    <option></option>
                </select>
            </div>
            <div class="form-group">
                <label asp-for="ContactName" class="control-label"></label>
                <input asp-for="ContactName" class="form-control" />
                <span asp-validation-for="ContactName" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ContactPhone" class="control-label"></label>
                <input asp-for="ContactPhone" class="form-control" />
                <span asp-validation-for="ContactPhone" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Image" class="control-label"></label>
                <input asp-for="Image" type="file" accept="image/*" class="form-control" />
                <span asp-validation-for="Image" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="AdCreate" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

FourthMVCAppMy/Views/Ad/Details.cshtml
@using FourthMVCAppMy.DAL.Entities
@using Microsoft.AspNetCore.Identity
@model FourthMVCAppMy.Models.Ads.AdModel
@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{
    ViewData["Title"] = "Details";
}

<h1>Подробно</h1>

<div>
    <hr />
    @switch (Model.RecordImageType)
    {
        case RecordImageType.Db:
            if (Model.Image != null && Model.Image.Length > 0)
            {
                <img style="width: 50%; height: 50%" src="data:image/jpeg;base64,@(Convert.ToBase64String(Model.Image))" />
            }
            break;
        case RecordImageType.Disk:
            if (!string.IsNullOrWhiteSpace(Model.ImagePath))
            {
                <img style="width: 50%; height: 50%" src="@Url.Content(Model.ImagePath)" />
            }
            break;
    }
    <dl class="row">
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.DateOfСreation)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DateOfСreation)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Author)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Author)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Title)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Title)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.Price)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Price)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.ContactName)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ContactName)
        </dd>
        <dt class="col-sm-6">
            @Html.DisplayNameFor(model => model.ContactPhone)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ContactPhone)
        </dd>
    </dl>

    <table id="commentsTable" class="table">
        <tbody>
            @foreach (var item in Model.Comments)
            {
                <tr>
                    <td>
                        @Html.DisplayFor(modelItem => item.DateOfPublication)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.Author)
                    </td>
                    <td>
                        @Html.DisplayFor(modelItem => item.CommentContent)
                    </td>
                    <td></td>
                </tr>
            }
        </tbody>
    </table>
</div>

<div id="gallery">
    @foreach (var galleryImage in Model.Images)
    {
        if (galleryImage.Image != null && galleryImage.Image.Length > 0)
        {
            <img style="width: 20%; height: 20%" src="data:image/jpeg;base64,@(Convert.ToBase64String(galleryImage.Image))" />
        }
    }
</div>

@if (SignInManager.IsSignedIn(User))
{
    <div><input type="button" id="addComment" class="btn-primary" value="Comment" /></div>
    <div id="commentForm" style="display: none">
        <div><textarea id="commentText" class="form-control"></textarea></div>
        <div><input type="button" id="sendComment" class="btn-primary" value="Send" /></div>
    </div>
}
else
{

}
<br />
@if (SignInManager.IsSignedIn(User))
{
    
        var galleryImageCreateModel = new GalleryImageCreateModel()
        {
            AdId = Model.Id
        };

    <partial name="_GalleryImagesPartial" model="@galleryImageCreateModel" />

}
else
{

}

<br />
<a asp-action="Index">Back to List</a>



@section Scripts
{
    <script>

        $('#addComment').click(function () {
            $('#commentForm').show();
            $('#addComment').hide();
        });

        $('#sendComment').click(function () {

            var commentContent = $('#commentText').val();
            var adId = '@Model.Id';
            $.ajax({
                url: '@Url.Action("AddComment", "Ad")',
                method: 'POST',
                data: { 'commentContent': commentContent, 'adId': adId },
                dataType: 'JSON',
                error: function (data) {
                    console.log(data);
                    alert('Error ' + data.status + "\n" + data.responseText);
                },
                success: function (data) {
                    $('#commentForm').hide();
                    $('#addComment').show();
                    var dateOfPublicationCell = "<td>" + data.dateOfPublication + "</td>";
                    var authorCell = "<td>" + data.author + "</td>";
                    var сommentContentCell = "<td>" + data.commentContent + "</td>";
                    var newRow = "<tr>" + dateOfPublicationCell + authorCell + сommentContentCell + "</tr>";
                    $('#commentsTable tbody').append(newRow);
                }
            });
        });

        $('#uploadImages').on('click', function () {
            var files = document.getElementById('uploadFile').files;
            if (files.length > 0) {
                var data = new FormData();
                for (var i = 0; i < files.length; i++) {
                    data.append("file" + i, files[i]);
                }

                $.ajax({
                    type: 'POST',
                    url: '@Url.Action("UploadAjax", "Ad")' + '/?adId=' + $('#adId').val(),
                    contentType: false,
                    processData: false,
                    data: data,
                    success: function (data) {
                        for (var i = 0; i < data.length; i++) {
                            var img = '<img style="width: 20%; height: 20%" src="data:image/jpeg;base64,' +
                                data[i].image +
                                '"/>';
                            $('#gallery').append(img);
                        }
                    },
                    error: function(data) {
                        alert(data);
                    }
                });
            }
        })

    </script>
}

FourthMVCAppMy/Views/Ad/Index.cshtml
@model FourthMVCAppMy.Models.Ads.AdFilterModel

@{
    ViewData["Title"] = "Index";
}

<p>
    <a asp-action="AdCreate">Добавить объявление</a>
</p>
<div class="row">
    <div class="col-md-4">
        <form asp-action="Index" method="get">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="SearchKey" class="control-label"></label>
                <input asp-for="SearchKey" class="form-control" value="@Model.SearchKey" />
                <span asp-validation-for="SearchKey" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PriceFrom" class="control-label"></label>
                <input asp-for="PriceFrom" class="form-control" value="@Model.PriceFrom" />
                <span asp-validation-for="PriceFrom" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PriceTo" class="control-label"></label>
                <input asp-for="PriceTo" class="form-control" value="@Model.PriceTo" />
                <span asp-validation-for="PriceTo" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Search" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<table class="table">
    <tbody>
        @foreach (var item in Model.Ads.OrderByDescending(s => s.Id))
        {
        <tr>
            <td>
                <img style="width: 15%; height: 10%" src="data:image/jpeg;base64,@(Convert.ToBase64String(item.Image))" />
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Author)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.DateOfСreation)
            </td>
            <td>
                <a asp-action="Details" asp-route-adId="@item.Id">
                    @Html.DisplayFor(modelItem => item.Title)
                </a>
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Price)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Categories)
            </td>
        </tr>
        <tr>
            <td>
                <a asp-action="Details" asp-route-adId="@item.Id">
                    @Html.DisplayFor(modelItem => item.Description)
                </a>
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ContactName)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ContactPhone)
            </td>
        </tr>
        }
    </tbody>
</table>

FourthMVCAppMy/Views/Ad/_GalleryImagesPartial.cshtml
@model GalleryImageCreateModel
<div>
    <input type="file" multiple="multiple" name="upload" id="uploadFile" />
    <input type="hidden" id="adId" value="@Model.AdId" />
    <input type="button" value="Upload" id="uploadImages" />
</div>